PPATH  Prime Path
The ministers of the cabinet were quite upset by the
message from the Chief of Security stating that they
would all have to change the fourdigit room numbers
on their offices.
— It is a matter of security to change such things
every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good
reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also
a prime. You will just have to paste four new
digits over the four old ones on your office door.
— No, it's not that simple. Suppose that I change the
first digit to an 8, then the number will read 8033
which is not a prime!
— I see, being the prime minister you cannot stand
having a nonprime number on your door even for a
few seconds.
— Correct! So I must invent a scheme for going from
1033 to 8179 by a path of prime numbers where
only one digit is changed from one prime to the
next prime.
Now, the minister of finance, who had been eavesdropping,
intervened.
— No unnecessary expenditure, please! I happen to
know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to
minimize the cost. You don't know some very cheap
software gurus, do you?
— In fact, I do. You see, there is this programming
contest going on...
Help the prime minister to find the cheapest prime path between any two given fourdigit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033 1733 3733 3739 3779 8779 8179The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are fourdigit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Example
Input: 3 1033 8179 1373 8017 1033 1033 Output: 6 7 0
hide comments
abhishekrahul:
20170119 13:52:25
enjoyed solving the problem ,very good question ,, it took some time ,, my 100th on spoj ............. 

code_aim:
20161220 21:04:08
Very Good Question!! 

vandan1177:
20161113 16:02:32
Can someone please explain me the line  "that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased." 

hpatel:
20160822 21:44:03
Good application of BFS ! 

square1001:
20160726 06:35:51
It is interesting, but I solved in 1520 minutes :) 

baadshah_:
20160715 21:52:08
AC in one GO!!nice problem


manohar_4139:
20160607 16:59:01
AC in one go..) nice problem 

ajay_5097:
20160526 16:11:07
My first on BFS !! Nice one :) Last edit: 20160526 16:11:36 

hulk_baba:
20160525 00:00:02
It's not necessary that the transitioning prime number lies between the 2 numbers, it may be greater. so be careful while bfs; 

vijay kumar paliwal:
20160523 13:32:11
M Lovin' It! 
Added by:  overwise 
Date:  20071002 
Time limit:  2s 
Source limit:  50000B 
Memory limit:  1536MB 
Cluster:  Cube (Intel G860) 
Languages:  All except: ERL JSRHINO NODEJS PERL6 VB.NET 
Resource:  ACM ICPC NWERC 2006 